#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSTRLEN 256
#define NUMESAMI 10 	/* nel caso reale saranno di piu`  */
#define MAXSTUDENTI 10 	/* nel caso reale saranno di piu` */

int main()
{
	int i = 0, j = 0;
	char nome[MAXSTRLEN];
	char esame[MAXSTRLEN];

	struct esame
	{
		char nome[MAXSTRLEN];
		int voto;
	};

	struct studente
	{
		char nome[MAXSTRLEN];
		int matricola;

		struct esame esami[NUMESAMI];
	};


	/* in questa riga si puo` osservare l'inizializzazione */
	struct studente studenti[MAXSTUDENTI] = { "NoName", 1, { { "Mat1", 1 }, {"Mat2", 2 } }, "Stud2", 2, { { "Mat2.1", 3}, { "Mat2.2", 4} } };
	/* gli elementi non inizializzati esplicitamente vengono posti a zero.
	 */

	/* La stampa seguente mostra il vettore studenti e fa vedere che i primi due elementi sono
	 * inizializzati ai valori imposti all'istruzione precedente, mentre tutti gli altri
	 * elementi sono automaticamente posti a zero.
	 */

	for( i = 0; studenti[i].matricola >= 0 && i < MAXSTUDENTI; i++)
	{
		printf("%s [%d]:\n", studenti[i].nome, studenti[i].matricola);
		/* discorso analogo per gli esami. Suppongo che la lista degli esami 
		 * termini quando il voto e` pari a zero.
		 */
		for(j = 0;  studenti[i].esami[j].voto >= 0 && j < NUMESAMI; j++)
		{
			printf("%d.\tmateria: \"%s\"\tvoto %d\n", j+1, studenti[i].esami[j].nome, studenti[i].esami[j].voto);
		}
	}

	/* reinizializzo i a zero */
	i = 0;

	while(i < MAXSTUDENTI)
	{
		
		printf("Inserisci nome studente (# per terminare): ");
		/* NOTA: fgets salva il '\n' in nome.
		 * Se voglio rimuoverlo, lo devo fare esplicitamente.
		 */
		fgets(nome, MAXSTRLEN, stdin);
		
		if(strncmp(nome, "#", 1) == 0)
			break;
		/* strncpy(char *s1, const char *s2, int n) copia non piu` di n byte da s2 a s1 */
		strncpy(studenti[i].nome, nome, strlen(nome) - 1); /* -1 per non copiare il '\n' finale */
		printf("Inserisci numero di matricola: ");
		scanf("%u", &studenti[i].matricola);
		while(getchar() != '\n');
		
		j = 0; /* inizializzo j per ogni studente */
		while(j < NUMESAMI)
		{
			printf("Inserisci il nome della materia d'esame (# per terminare): ");
			fgets(esame, MAXSTRLEN, stdin);
			if(strncmp(esame, "#", 1) == 0) /* vedi sopra: avrei anche '\n' per cui controllo solo il primo char */
				break; /* esco dal ciclo while (j ... ) */
			/* salvo esame nel campo appropriato della struttura */
			strcpy(studenti[i].esami[j].nome, esame);
			printf("Inserisci il voto: ");
			scanf("%u", &studenti[i].esami[j].voto);
			printf("voto letto %u\n", studenti[i].esami[j].voto);
			while(getchar() != '\n');
			j++;
		}
		

		i++; /* incremento il contatore del numero di studenti */
	}

	/* esco dal ciclo
	 * 1. quando trovo la matricola pari a 0;
	 * 2. i raggiunge la massima capacita` del vettore di strutture 
	 */
	for( i = 0; studenti[i].matricola > 0 && i < MAXSTUDENTI; i++)
	{
		printf("\"%s\" [%d]:\n", studenti[i].nome, studenti[i].matricola);
		/* discorso analogo per gli esami. Suppongo che la lista degli esami 
		 * termini quando il voto e` pari a zero.
		 */
		for(j = 0;  studenti[i].esami[j].voto > 0 && j < NUMESAMI; j++)
		{
			printf("%d.\tmateria: \"%s\"\tvoto %d\n", j+1, studenti[i].esami[j].nome, studenti[i].esami[j].voto);
		}
	}
	
}


