#include <stdio.h>
#include <stdlib.h>

#include "rettangoli.h" /* deve essere nella stessa cartella! */

int main()
{
	struct rect r1, r2;
	struct rect temp;
	struct rect vrect[2];
	int i;
	printf("inserisci x1,y1, x2,y2 del primo rettangolo: ");
	scanf("%d %d %d %d", &r1.p1.x, &r1.p1.y, &r1.p2.x, &r1.p2.y);

	printf("inserisci x1,y1, x2,y2 del secondo rettangolo: ");
	scanf("%d %d %d %d", &r2.p1.x, &r2.p1.y, &r2.p2.x, &r2.p2.y);
	
	/* trasformiamo i rettangoli in forma canonica, se necessario. Cioe` con il primo punto
	 * in basso a sinistra e il secondo in alto a destra.
	 * Per comodita`, salviamo i due rettangoli in un vettore e sfruttiamo un ciclo for
	 * per evitare di duplicare il codice per ogni rettangolo.
	 */
	vrect[0] = r1; /* copia tra strutture, ok, copia campo per campo */
	vrect[1] = r2;

	for(i =0 ; i < 2; i++)
	{
		printf("rettangolo %d in forma non canonica: p1(%d,%d) p2(%d,%d)\n", i + 1, vrect[i].p1.x, vrect[i].p1.y, vrect[i].p2.x, vrect[i].p2.y);
		if(vrect[i].p1.x > vrect[i].p2.x)
		{
			temp.p1.x = vrect[i].p1.x;
			vrect[i].p1.x = vrect[i].p2.x;
			vrect[i].p2.x = temp.p1.x;
		}
		if(vrect[i].p1.y > vrect[i].p2.y)
		{
			temp.p1.y = vrect[i].p1.y;
			vrect[i].p1.y = vrect[i].p2.y;
			vrect[i].p2.y = temp.p1.y;
		}
		printf("rettangolo %d in forma canonica p1(%d,%d) p2(%d,%d)\n", i + 1, vrect[i].p1.x, vrect[i].p1.y, vrect[i].p2.x, vrect[i].p2.y);
	}

	r1 = vrect[0];
	r2 = vrect[1];

	/* vediamo se r2 e` contenuto in r1 */
	if(r2.p1.x >= r1.p1.x && r2.p1.y >= r1.p1.y && r2.p2.x < r1.p2.x && r2.p2.y < r1.p2.y)
		printf("r2 contenuto in r1\n");
	else
		printf("r2 non e` contenuto in r1\n");

	return EXIT_SUCCESS;
}


